package com.example.samplenaviagtioncompose

import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.activity.enableEdgeToEdge
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import androidx.navigation.toRoute
import com.example.samplenaviagtioncompose.screen.ScreenOne
import com.example.samplenaviagtioncompose.screen.ScreenTwo
import com.example.samplenaviagtioncompose.ui.theme.SampleNaviagtionComposeTheme
import kotlinx.serialization.Serializable

class MainActivity : ComponentActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
        setContent {
            var navController = rememberNavController()
            SampleNaviagtionComposeTheme {
                NavHost(navController, startDestination = One(sampleText = "myText")){
                    composable<One> {
                        val one: One = it.toRoute()
                        ScreenOne(one) {
                            navController.navigate(route = Two)
                        }
                    }
                    composable<Two> {
                        ScreenTwo(onNavigateToScreenOne = {
                            navController.navigate(route = One("from second scree"))
                        }
                        )
                    }
                }
            }
        }
    }
}

@Serializable
data class One(val sampleText: String)

@Serializable
object Two

